<hr>
<p>
    Sada kada smo naučili kako su bistabili izgrađeni, definiciju bistabila i njihov osnovni način rada, promotrit ćemo
    i ostale bistabile.
</p>

<p>
    Za početak pogledat ćemo osnovnu implementaciju bistabila <b>JK</b>. Bistabil <b>JK</b> dobio je ime po Jacku
    Kilbyu,
    zanimljivu povijesnu crticu o tome možete pročitati pri kraju ove lekcije.
</p>
<hr>
<p>
    Na sljedećoj simulaciji nalazi se jedna moguća izvedba bistabila <b>JK</b>. Bistabil <b>JK</b> ostvarili smo pomoću
    osnovnog
    bistabila <b>SR</b> kojeg smo upoznali u prošloj minilekciji. Jedini dodatak ovom bistabilu su dva logička sklopa
    <b>I</b>. Promotrite način njihovog spajanja.
    <br><br>
    Na ulazima prvog sklopa <b>I</b> su: \(J\) i \(\overline{Q}\). Drugom sklopu, ulazi su \(K\) i \(Q\).
    Bistabilu je moguće promijeniti stanje samo pri visokoj razini signala takta, odnosno dok je \(CP = 1\). U
    situacijama kada to nije slučaj, stanje se ne mijenja. Kako bi isprobali ponašanje ovog sklopa, postavit ćemo \(CP\)
    u visoku razinu.
</p>

<p>
    Ideja bistabila <b>JK</b> jest da upravljanje bistabilom <b>SR</b> bude potpuno, odnosno da su sve kombinacije na
    ulazima <b>J</b> i <b>K</b> dozvoljene. To su redom: <code>00</code>, <code>01</code>, <code>10</code>,
    <code>11</code>. Takav bistabil nazivamo i univerzalni bistabil. Pomoću bistabila <b>JK</b> možemo ostvariti i
    ostale bistabile, koje ćemo proučavati kasnije u ovoj lekciji.
</p>
<hr>
<p>
    Sada ćemo proanalizirati ovakvu izvedbu bistabila <b>JK</b> i odsimulirati sve kombinacije na ulazima <b>J</b> i <b>K</b>.
</p>

<p>
    Pretpostavimo da je bistabil u stanju <code>1</code>, <b>J</b> i <b>K</b> su <code>0</code> i CP je <code>1</code>.
    Nakon čitanja teksta predviđenog za pojedinu kombinaciju, isprobajte opisani slučaj na simulaciji i uvjerite se da
    se bistabil ponaša na opisani način.
</p>

<h3 style="color:darkred"><b>Napomene</b></h3>
<p style="color:darkblue;font-style:italic">
    Na sljedećim simulacijama dodano je i kašnjenje logičkih sklopova (na takvim se simulacijama na dnu nalazi iznos
    kašnjenja). Vrijeme kašnjenja iznosi 1 sekundu (odnosno 1000 milisekunda).
    Zbog ovakvog kašnjenja, pripazite da ne mijenjate vrijednost signala takta (CP-a, a i ulaza J i K) prebrzo. Ako se
    iz tog razloga simulacija počne ponašati čudno (kažemo još: poput svjetleće diode) slobodno ponovno učitajte
    stranicu i nastavite od tamo gdje ste stali.
</p>

<hr>
<h4>\(Kombinacija \ J,\ K,\ CP = (0,\ 0,\ 1) \)</h4>
<p>
    Krenimo s prvom kombinacijom. Razmotrimo situaciju kada su <b>J</b> i <b>K</b> na <b>0</b> i bistabil je u stanju 1.
    Postavite CP na vrijednost 1 (ako ste ga mijenjali, inicijalno je <b>CP</b> = 1). Stanje bistabila neće se
    promijeniti. </p>
<p style="color:darkred">Zašto?</p>
<p> Naime, pogledajmo prvu razinu logičkih sklopova <b>I</b>.<br>

    <b>Prvi sklop</b> na svojem ulazu vidi: \(J = 0 \hskip 3mm i \hskip 3mm \overline{Q} = 0\); pa je izlaz \(0 \cdot 0
    = 0\).<br>
    <b>Drugi sklop</b> na svojem ulazu vidi: \(K = 0 \hskip 3mm i \hskip 3mmQ = 1\); pa je izlaz \(0 \cdot 1 = 0\)
    <br><br>
    Kako <b>prvi sklop</b> generira vrijednost ulaza S bistabila <b>SR</b>, tako je ulaz S = <b>0</b>.
    Kako <b>drugi sklop</b> generira vrijednost ulaza R bistabila <b>SR</b>, tako je ulaz R = <b>0</b>.
    Ova kombinacija (<code>00</code>) za <b>SR</b> bistabil znači da nema promjene stanja. Pa će i naš bistabil
    <b>JK</b> ostati u stanju <b>1</b>.
</p>
<hr>

<div>
    <p align="center">
        <canvas id="jkFlipFlop1" width="800px" height="500px"></canvas>
    </p>
</div>
<hr>

<h4>\(Kombinacija \ J,\ K,\ CP = (1,\ 0,\ 1) \)</h4>
<p>
    Promotrimo sada i kombinaciju <b>J</b>, <b>K</b> = (1, 0). Napravite potrebne promjene kako biste podesili ovu
    kombinaciju i ostavite CP u jedinici. Pazite, vrijeme kašnjenja logičkih sklopova je 1 s pa dajte sklopu vremena da
    odreagira.
    Za ovu kombinaciju bistabil će ostati u stanju <b>1</b> (ako je već bio u tom stanju) ili prijeći u njega (ako je
    bistabil bio u stanju <b>0</b>). </p>
<p style="color:darkred">Zašto?</p>

<p>
    Pogledat ćemo ponovo što se događa s prvom razinom logičkih sklopova <b>I</b>.
    <br><br>
    <b>Prvi sklop</b> na svojem ulazu vidi: \(J = 1 \hskip 3mm i \hskip 3mm\overline{Q} = 0\); pa je izlaz \(1 \cdot 0 =
    0\).<br>
    <b>Drugi sklop</b> na svojem ulazu vidi: \(K = 0 \hskip 3mm i \hskip 3mmQ = 1\); pa je izlaz \(0 \cdot 1 = 0\)
    <br><br>
    Kako <b>prvi sklop</b> generira vrijednost ulaza S bistabila <b>SR</b>, tako je ulaz S = <b>0</b>.
    Kako <b>drugi sklop</b> generira vrijednost ulaza R bistabila <b>SR</b>, tako je ulaz R = <b>0</b>.
    Ova kombinacija (<code>00</code>) za bistabil <b>SR</b> znači da nema promjene stanja. Pa će i naš bistabil
    <b>JK</b> ostati u stanju <b>1</b>.
    <br><br>
    Kada bi bistabil bio u stanju <code>0</code>, <b>prvi sklop</b> računao bi: \(1 \cdot 1 = 1\). Sada bi S bio
    <b>1</b> pa bi bistabil <b>JK</b> iz stanja <b>0</b> otišao u <b>1</b>.
</p>


<div>
    <p align="center">
        <canvas id="jkFlipFlop2" width="800px" height="500px"></canvas>
    </p>
</div>

<hr>
<h4>\(Kombinacija \ J,\ K,\ CP = (0,\ 1,\ 1) \)</h4>
<p>
    Za ovu kombinaciju ulaza <b>J</b> i <b>K</b>, bistabil bi se trebao resetirati (ili ostati u stanju <b>0</b> ako je
    prethodno bio u tom stanju). </p>
<p style="color:darkred">Zašto?</p>


<p>
    Pogledat ćemo ponovo što se događa s prvom razinom logičkih sklopova <b>I</b>.
    <br><br>
    <b>Prvi sklop</b> na svojem ulazu vidi: \(J = 0 \hskip 3mm i \hskip 3mm\overline{Q} = 0\); pa je izlaz \(0 \cdot 0 =
    0\).<br>
    <b>Drugi sklop</b> na svojem ulazu vidi: \(K = 1 \hskip 3mm i \hskip 3mmQ = 1\); pa je izlaz \(1 \cdot 1 = 1\)
    <br><br>
    Kako <b>prvi sklop</b> generira vrijednost ulaza S bistabila <b>SR</b>, tako je ulaz S = <b>0</b>.
    Kako <b>drugi sklop</b> generira vrijednost ulaza R bistabila <b>SR</b>, tako je ulaz R = <b>1</b>.
    Ova kombinacija (<code>01</code>) resetira bistabil <b>SR</b>. Pa će bistabil <b>JK</b> prijeći u stanje <b>0</b>
    (ili ostati u tom stanju ako je prethodno u njemu bio).
    <br><br>
    Kada bi bistabil bio u stanju <code>0</code>, <b>drugi sklop</b> računao bi: \(0 \cdot 1 = 0\). Sada bi S i R bili
    <b>0</b> (provjerite sami za ulaz S) pa bi bistabil <b>JK</b> ostao u prethodnom stanju.
</p>

<hr>

<div>
    <p align="center">
        <canvas id="jkFlipFlop3" width="800px" height="500px"></canvas>
    </p>
</div>

<hr>
<p>
    Do sada nismo vidjeli nikakvu razliku u ponašanju ovog bistabila (bistabil <b>JK</b>) u odnosu na bistabil <b>SR</b>.
    Međutim, preostaje nam ispitati i zadnju kombinaciju ovog bistabila. Napravite potrebne promjene na sljedećoj
    simulaciji tako da postavite i zadnju kombinaciju.
</p>
<hr>
<h4>\(Kombinacija \ J,\ K,\ CP = (1,\ 1,\ 1) \)</h4>
<p>
    Kako sada imamo oba ulaza (<b>J</b> i <b>K</b>) u jedinici, da bi se bistabil postavio ili resetirao dovoljno je da
    jedan izlaz (\(Q\) ili \(\overline{Q}\)) bistabila bude <b>1</b>. Pogledajmo ovo na primjeru.

    Pretpostavimo da je stanje bistabila \(Q = 1\) i pogledajmo prvu razinu logičkih sklopova <b>I</b>. <br><br>

    <b>Prvi sklop</b> na svojem ulazu vidi: \(J = 1 \hskip 3mm i \hskip 3mm\overline{Q} = 0\); pa je izlaz \(1 \cdot 0 =
    0\).<br>
    <b>Drugi sklop</b> na svojem ulazu vidi: \(K = 1 \hskip 3mm i \hskip 3mmQ = 1\); pa je izlaz \(1 \cdot 1 = 1\)
    <br><br>
    Kako <b>prvi sklop</b> generira vrijednost ulaza S bistabila <b>SR</b>, tako je ulaz S = <b>0</b>.
    Kako <b>drugi sklop</b> generira vrijednost ulaza R bistabila <b>SR</b>, tako je ulaz R = <b>1</b>.
    Izgleda da će bistabil prijeći iz stanja \(Q = 1\) u stanje \(Q = 0\).<br><br>
    No što će se zaista dogoditi? Nakon što bistabil prijeđe u stanje <b>0</b>, vrijednosti se mijenjaju, sada će
    vrijediti: \(Q = 0\) i \(\overline{Q} = 1\).
    Pogledamo li ponovo <b>prvi</b> i <b>drugi</b> sklop I, vidimo da će takva promjena izazvati promjenu ulaza S i R,
    tako da je S = <b>1</b>, a R = <b>0</b>. Ova kombinacija (<code>10</code>) za bistabil <b>SR</b> znači postavljanje.
    Bistabil će prijeći iz stanja \(Q = 0\) u stanje \(Q = 1\).
    <br><br>
    Ovakvo ponašanje nazivamo osciliranje i ovaj će bistabil oscilirati (mijenjati stanje iz <b>0</b> u <b>1</b> pa u
    <b>0</b> pa ponovo u <b>1</b> i tako dalje) sve dok je CP u visokoj razini.

    U nastavku ćemo rezimirati sve što smo dosad isprobali i pogledati tablicu promjene stanja bistabila <b>JK</b>.
</p>

<hr>
<div>
    <p align="center">
        <canvas id="jkFlipFlop4" width="800px" height="500px"></canvas>
    </p>
</div>
<hr>
<p>
    Sada možemo pogledati i tablicu promjene stanja ovog bistabila.
</p>

<div class="mlTableCaption"><span class="mlTblKey">Tablica 1.</span> Tablica promjene stanja <b>bistabila JK</b>.</div>

<div align="center">
    <table class="mlTableCC mlTableVR2">
        <thead>
        <tr>
            <th>\(J\)</th>
            <th>\(K\)</th>
            <th>\(Q_{n+1}\)</th>
        </tr>
        </thead>

        <tbody>
        <tr>
            <td>0</td>
            <td>0</td>
            <td>\(Q_{n}\)</td>
        </tr>

        <tr>
            <td>0</td>
            <td>1</td>
            <td>0</td>
        </tr>

        <tr>
            <td>1</td>
            <td>0</td>
            <td>1</td>
        </tr>
        <tr>
            <td>1</td>
            <td>1</td>
            <td>\(\overline{Q_n}\)</td>
        </tr>
        </tbody>
    </table>
</div>
<hr>
<p>
    Kako smo popunili tablicu?
    U prethodnim simulacijama isprobali smo sve kombinacije ulaza <b>J</b> i <b>K</b>. Za pobudu 0, 0 (prvi redak
    tablice) dobili smo pobudu <code>00</code> na ulazima bistabila <b>SR</b>, što znači da nema promjene stanja, to smo
    označili kao \(Q_n\), što predstavlja trenutno stanje bistabila. <br><br>
    Za pobudu 0, 1 (u drugom retku) bistabil <b>SR</b> će vidjeti kombinaciju <code>01</code>, a to će <b>resetirati</b>
    bistabil. Slično imamo i za kombinaciju <code>10</code> (treći redak; <b>setiranje</b> bistabila). Za prethodne
    kombinacije (<code>01</code> i <code>10</code> bistabil će se resetirati odnosno postaviti, ako već nije bio u
    stanju u koje prelazi. <br><br>
    U zadnjem retku imamo i kombinaciju <code>11</code>, za koju smo uočili osciliranje bistabila <b>JK</b>. Kako je
    bistabil malo u stanju 0, pa <b>1</b>, pa opet <b>0</b> i tako u krug, sljedeće je stanje uvijek obrnuto od
    trenutnog. Pa imamo da je sljedeće stanje: \(\overline{Q}\), što predstavlja komplement trenutnog stanja.
</p>

<hr>
<p>
    Na sljedećoj simulaciji možete pogledati simbol bistabila <b>JK</b>, njegovu tablicu promjene stanja i dijagram
    promjene stanja. I na ovoj simulaciji isprobajte prethodno opisano ponašanje.<br><br>
    Kroz dijagram promjene stanja ovog bistabila možete pratiti trenutno stanje bistabila (označeno
    <text style="color: darkmagenta">ljubičastim obrubom</text>
    ) i sljedeće stanje (označeno strelicom
    <text style="color: #da0000">crvene</text>
    boje). Uočite da će bistabil mijenjati stanje nakon određenog vremena kašnjenja. Kašnjenje je dodano kako bi ljepše
    vidjeli promjenu stanja kod dijagrama.
    </text>
<hr>
<div>
    <p align="center">
        <canvas id="symbolJK" width="700px" height="600px"></canvas>
    </p>
</div>
<hr>

<p>
    <text style="color:darkred">Na sljedećoj stranici pogledat ćemo i kako riješiti oscilacije kod bistabila <b>JK</b>.
    </text>
</p>
<script>
    /*@#page-include#(library.js)*/
    /*@#page-include#(example1C1.js)*/
    /*@#page-include#(example1C2.js)*/
    /*@#page-include#(example1C3.js)*/
    /*@#page-include#(example1C4.js)*/
    /*@#page-include#(symbolJK.js)*/
</script>